package com.huimv.eartag2.manage2.netty;

import cn.hutool.core.util.ObjectUtil;
import cn.hutool.json.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.huimv.eartag2.manage2.pojo.EartagDeviceRegister;
import com.huimv.eartag2.manage2.pojo.EartagEartagRegister;
import com.huimv.eartag2.manage2.service.IEartagDeviceRegisterService;
import com.huimv.eartag2.manage2.service.IEartagEartagRegisterService;
import io.netty.buffer.ByteBuf;
import io.netty.buffer.Unpooled;
import io.netty.channel.ChannelHandler;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.ChannelInboundHandlerAdapter;
import io.netty.util.CharsetUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Component;
import org.springframework.web.client.RestTemplate;

import java.text.ParseException;
import java.util.Date;
import java.util.List;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@ChannelHandler.Sharable
@Component
@Slf4j
public class EartagServerHandler2 extends ChannelInboundHandlerAdapter {
    private StringBuilder askTextSb = null;
@Autowired
private IEartagEartagRegisterService eartagRegisterService;
    @Autowired
    private IEartagDeviceRegisterService deviceRegisterService;

    @Autowired
    private RestTemplate restTemplate ;
    //
    public void appendClientAsk(String text){
        if(this.askTextSb == null){
            askTextSb = new StringBuilder();
        }
        askTextSb.append(text);
    }

    @Override
    public void channelRead(ChannelHandlerContext ctx, Object msg) throws Exception {
        ByteBuf data = (ByteBuf) msg;
        String clientAskText = data.toString(CharsetUtil.UTF_8);
//        System.out.println((++num)+"次, 客户端消息clientAskText>>"+clientAskText);
        //保存实例内的客户端请求
        appendClientAsk(clientAskText);
    }

    @Override
    public void channelReadComplete(ChannelHandlerContext ctx) throws Exception {
//        ctx.writeAndFlush("111");
//        System.out.println("EchoServerHandle channelReadComplete");
        if(askTextSb.toString().indexOf("end") != -1){
//            System.out.println("askTextSb.内容()>>"+askTextSb.toString());
//            System.out.println("askTextSb.内容长度>>"+askTextSb.length());
//            System.out.println("输入完成.");
            // 处理客户端消息
            handleClientEartagMessage(askTextSb.toString(),ctx);
            //清空重置;
            askTextSb.delete(0,askTextSb.length());
//            System.out.println("清空sb实例. 长度>>"+askTextSb.length());
        }
    }

    @Override
    public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) throws Exception {
//        System.out.println("cause.getMessage()>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"+cause.getMessage());
        if(cause.getMessage().indexOf("Connection reset") != -1){
            log.info("相关采集器设备正在重启:"+cause.toString());
        }
//        cause.printStackTrace();
        ctx.close();
    }



    private   void handleClientEartagMessage(String clientAskText, ChannelHandlerContext ctx) throws ParseException, JsonProcessingException {
        clientAskText = clientAskText.replaceAll("\r","").replaceAll("\n","");
        System.out.println("clientAskText--------------->" +clientAskText);
//hm+7+868977051335099+122083123610011+0+end

        String[] split = clientAskText.split("\\+");


//        if ("6".equals(split[1])){
//
//            System.out.println("pliersDemo------------->" +clientAskText);
//            ctx.writeAndFlush(Unpooled.copiedBuffer("hm+6+0+115.238.57.190+8013+8+end".getBytes()));
//        }

        if ("7".equals(split[1])){


            //hm+7+868977051335099+122083123610011+22450+184902913+0+end
            String eartag = split[3];
            String device = split[2];
            EartagDeviceRegister deviceRegister = deviceRegisterService.getOne(new QueryWrapper<EartagDeviceRegister>().eq("device_code", device));
            if(ObjectUtil.isNotEmpty(deviceRegister)){
                EartagEartagRegister eartagEartagRegister = new EartagEartagRegister();
                eartagEartagRegister.setEarmark(eartag);
                eartagEartagRegister.setFirstDevice(device);
                eartagEartagRegister.setRegisterTime(new Date());
                eartagEartagRegister.setRegisterType(2);
                eartagEartagRegister.setFarmId(deviceRegister.getFarmId());
                eartagEartagRegister.setCreateDate(new Date());

                eartagRegisterService.save(eartagEartagRegister);
                ctx.writeAndFlush(Unpooled.copiedBuffer("hm+7+8+end".getBytes()));
            }





        }

    }


//hm+7+868977051335099+122083123610011+0+end
    //hm+6+868977051335099+0+end

}
